#include <bits/stdc++.h>

using namespace std;

#define MAXN 100000


int main() {
    int N;

    assert(1 == scanf("%d", &N));
    
    // let's store the tree with an adjacent list
    vector<int> adj[N];
    
    for (int i=0, X, Y; i<N-1; i++) {
        assert(2 == scanf("%d %d", &X, &Y));
        adj[X-1].push_back(Y-1);
        adj[Y-1].push_back(X-1);
    }
    
    int children[N];    // number of children to be processed
    int max_child[N];   // size of the largest child
    int parent[N];      // size of the remaining part of the tree
    stack<int> s;
    for(int i = 0; i < N; i++) {
        children[i] = adj[i].size() - 1;    // one adjacent node is the parent
        max_child[i] = 0;                   // no children has been processed
        parent[i] = N-1;
        if(children[i] == 0) s.push(i);     // we start from leaves
    }
    
    while(!s.empty()) {
        int i = s.top();
        s.pop();
        for(auto x : adj[i]) {
            if(children[x] == 0) continue;
            
            // x is the parent of i: let's propagate some information from i to x
            max_child[x] = max(max_child[x], N - parent[i]);
            parent[x] -= N - parent[i];
            
            // if all children of x have been processed, we can process x
            if(--children[x] == 0) s.push(x);
        }
    }
    
    // print all admissible solutions
    for(int i = 0; i < N; i++) if(max(max_child[i], parent[i]) <= N/2) printf("%d\n", i+1);
    
    return 0;
}
