#include <bits/stdc++.h>

using namespace std;

#define MAXN 1000

/*
    Recursive solution (60 points)

int d[MAXN];
int N;

int solve(int i = 0) {
    if(i >= N) return 0;
    if(i == 0) N--;
    int taking_i = d[i] + solve(i + 2);
    if(i == 0) N++;
    int not_taking_i = solve(i + 1);
    return max(taking_i, not_taking_i);
}

int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");
    
    in >> N;
    for(int i = 0; i < N; i++) in >> d[i];
    
    out << solve() << endl;
    
    return 0;
}
*/


/*
    Memoization
*/

int d[MAXN];
int N;

unordered_map<int, int> res;
int solve(int data = 0) {
    auto it = res.insert(make_pair(data, -1)).first;
    if(it->second == -1) {
        int i = data >> 1;
        int end_shift = data & 1;
        
        if(i >= N - end_shift) return 0;
        
        int taking_i = d[i] + solve(((i + 2) << 1) | (i == 0 ? 1 : end_shift));
        int not_taking_i = solve((i + 1) << 1 | end_shift);
        it->second = max(taking_i, not_taking_i);
    }
    return it->second;
}

int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");
    
    in >> N;
    for(int i = 0; i < N; i++) in >> d[i];
    
    out << solve() << endl;
    
    return 0;
}

