#include <stdio.h>
#include <assert.h>
#include <iostream>

using namespace std;

// move G_n out of the sum, so that
//      G_{n+1} := (n-1)*G_n - (G_{n-1} + ... + G_0)
// we only store G_n and the sum G_{n-1} + ... + G_0
int enumera(int N, int M) {
    // the sequence starts with -1, 0
    long long sum = -1;
    long long G_n = 0;
    
    for(long long n = 2; n <= N; n++) {
        // compute G_{n+1}
        long long G_np1 = ((n-1)*G_n - sum + M) % M;    // +M to keep it positive!
        
        // update sum and G_n for the next iteration
        sum = (sum + G_n) % M;
        G_n = G_np1;
    }
    
    return G_n;
}


int main() {
    FILE *fr, *fw;
    int N, M;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d%d", &N, &M));

    fprintf(fw, "%d\n", enumera(N, M));
    fclose(fr);
    fclose(fw);
    return 0;
}
