#include <stdio.h>
#include <assert.h>
#include <bits/stdc++.h>

using namespace std;

#define MAXN 10000

int H[MAXN+1];

/* recursion (30 points)
int passeggia(int N, int last_h, bool last_up) {
    if(N == 0) return 0;
    int taking = (last_up ? H[N-1] > last_h : H[N-1] < last_h) ? 0 : 1 + passeggia(N-1, H[N-1], !last_up);
    int not_taking = passeggia(N-1, last_h, last_up);
    return max(taking, not_taking);
}
*/


/* memoization (70 points)

inline int key(int N, int last_h, bool last_up) { return last_up + N*2 + last_h * (2*MAXN+2); }

unordered_map<int, int> res;

int passeggia(int N, int last_h, bool last_up) {
    if(N == 0) return 0;
    auto it = res.insert(make_pair(key(N, last_h, last_up), -1)).first;
    if(it->second == -1) {
        int taking = (last_up ? H[N-1] > last_h : H[N-1] < last_h) ? 0 : 1 + passeggia(N-1, H[N-1], !last_up);
        int not_taking = passeggia(N-1, last_h, last_up);
        it->second = max(taking, not_taking);
    }
    return it->second;
}
*/


// iterative (100 points)

int passeggia(int N) {
    int up[N], down[N];
    for(int i = 0; i < N; i++) {
        up[i] = down[i] = 1;
        for(int j = 0; j < i; j++) {
            if(H[j] < H[i]) up[i] = max(up[i], 1 + down[j]);
            else down[i] = max(down[i], 1 + up[j]);
        }
    }
    return max(up[N-1], down[N-1]);
}


int main() {
    FILE *fr, *fw;
    int N, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(1 == fscanf(fr, "%d", &N));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &H[i]));

    //fprintf(fw, "%d\n", max(passeggia(N, H[N-1], false), passeggia(N, H[N-1], true)));
    fprintf(fw, "%d\n", passeggia(N));
    fclose(fr);
    fclose(fw);
    return 0;
}
