#include <bits/stdc++.h>

using namespace std;

#define MAXN 100

int d[MAXN], s[MAXN];

/* recursion (40 points)
int solve(int i, int days = 365) {
    if(i < 0) return 0;
    days = min(days, s[i]);
    int taking = days - d[i] >= 0 ? 1 + solve(i-1, days - d[i]) : 0;
    int not_taking = solve(i-1, days);
    return max(taking, not_taking);
}
*/


/* memoization */

inline int key(int i, int days) { return i + days * (MAXN+1); }

unordered_map<int, int> res;

int solve(int i, int days = 365) {
    if(i < 0) return 0;
    days = min(days, s[i]);
    
    auto it = res.insert(make_pair(key(i, days), -1)).first;
    if(it->second == -1) {
        int taking = days - d[i] >= 0 ? 1 + solve(i-1, days - d[i]) : 0;
        int not_taking = solve(i-1, days);
        it->second = max(taking, not_taking);
    }
    return it->second;
}

int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");
    
    int N;
    in >> N;
    for(int i = 0; i < N; i++) in >> d[i] >> s[i];
    
    out << solve(N-1) << endl;
    
    return 0;
}
