#include <stdio.h>
#include <assert.h>
#include <bits/stdc++.h>

using namespace std;

#define MAXN 5000
#define MAXK 5000
#define MAXP 1000000

int P[MAXN];
int s[MAXN];
int K;

/* recursive (60 points); memoization would reach 80 points
int mangia(int N, int K) {
    if(K <= 0) return 0;
    if(N <= 0) return INT_MAX / 2;
    if(K > s[N-1]) return INT_MAX /2;
    
    int taking = P[N-1] + mangia(N-1, K - P[N-1]);
    int not_taking = mangia(N-1, K);
    return min(taking, not_taking);
}
*/

// in this case, generating all (meaningful) sums is affordable
int mangia(int N) {
    vector<int> sums;
    unordered_set<int> seen;
    
    sums.push_back(0);
    seen.insert(0);
    
    int res = INT_MAX;
    for(int j = 0; j < N; j++) {
        for(int i = sums.size() - 1; i >= 0; i--) {
            int x = sums[i] + P[j];
            if(x >= K) {
                if(x < res) res = x;
                continue;
            }
            if(seen.insert(x).second) sums.push_back(x);
        }
    }
    return res;
}


int main() {
    FILE *fr, *fw;
    int N, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d %d", &N, &K));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &P[i]));

    s[0] = P[0];
    for(int i = 1; i < N; i++) s[i] = s[i-1] + P[i];
    
    fprintf(fw, "%d\n", mangia(N));
    fclose(fr);
    fclose(fw);
    return 0;
}
