#include <bits/stdc++.h>

using namespace std;

#define MAXN 1000

int h[MAXN], c[MAXN];

/*
// recursion (35 points)
int solve(int N, int bound = 0) {
    if(N <= 0) return 0;
    int destroying = c[N-1] + solve(N-1, bound);
    int not_destroying = h[N-1] > bound ? solve(N-1, h[N-1]) : INT_MAX;
    return min(destroying, not_destroying);
}
*/

// memoization (100 points)

inline int key(int N, int bound) { return N + bound * (MAXN+1); }

unordered_map<int, int> res;

int solve(int N, int bound = 0) {
    if(N <= 0) return 0;
    auto it = res.insert(make_pair(key(N, bound), -1)).first;
    if(it->second == -1) {
        int destroying = c[N-1] + solve(N-1, bound);
        int not_destroying = h[N-1] > bound ? solve(N-1, h[N-1]) : INT_MAX;
        it->second = min(destroying, not_destroying);
    }
    return it->second;
}

int main() {
    ifstream in("input.txt");
    ofstream out("output.txt");
    
    int N;
    in >> N;
    for(int i = 0; i < N; i++) in >> h[i] >> c[i];
    
    out << solve(N) << endl;
    
    return 0;
}
